Scriptname MCSMagicEffectListScript extends activemagiceffect  

GlobalVariable Property MCSGlobalWaitFlag  Auto  
GlobalVariable Property MCSGlobalWaitFlagQuest  Auto  
GlobalVariable Property MCSGlobalEntryNumber  Auto  
Quest Property MCSQuest  Auto  
ReferenceAlias[] Property MCSAliasActor  Auto  ;0TempoA͔ԍ
LocationAlias[] Property MCSAliasLocation  Auto  ;\pB01ŁAĂ
ReferenceAlias[] Property MCSAliasAI  Auto  ;\pB01ŁAĂ
ObjectReference[] Property MCSMarkerActor  Auto  ;0TempoA͔ԍ
Cell Property MCSCellNowhere  Auto  
Cell Property MCSCellFollow  Auto  
ObjectReference Property MCSObjectAIEmptyRef  Auto  
ObjectReference Property MCSObjectAIFollowRef  Auto  
ObjectReference Property MCSObjectAIStayRef  Auto  
ObjectReference Property MCSObjectAIFreeRef  Auto  
ObjectReference Property MCSObjectAIDeadRef  Auto  
ObjectReference Property MCSObjectAIDisabledRef  Auto  
Message[] Property MCSMessageList  Auto  ;0List1ŁAĂ
Message Property MCSMessageListOrder  Auto  
Message Property MCSMessageListSneak  Auto  
Faction Property MCSFactionFollow  Auto  
Faction Property MCSFactionStay  Auto  
Int MCSPage
Int MCSDone ;0; 1:I
Int MCSEntryNumber
Int MCSLineNumber ;y[W̉ڂB0ځB
Int MCSButtonList
Actor MCSActor ;Ɨpɂ̓sxgp
Actor MCSActorSub ;ԓւp

Event OnEffectStart(Actor akTarget, Actor akCaster)

 If MCSGlobalWaitFlag.GetValueInt() == 1 ;If Busy
  Debug.Notification("Wait a Moment, and Retry.")
 Else

  MCSGlobalWaitFlag.SetValueInt(1) ;Tell Busy
  While MCSGlobalWaitFlagQuest.GetValueInt() == 1
  EndWhile
  MCSButtonList = 0
  If Game.GetPlayer().IsSneaking() == 1 ;Xj[N
   MCSButtonList = MCSMessageListSneak.Show() ;IvV\

   If MCSButtonList == 1 ;Call All Companions, and Make Them Follow
    MCSEntryNumber = 1
    While MCSEntryNumber < 99
     MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
     If MCSActor != None
      MCSMarkerActor[MCSEntryNumber].MoveTo(MCSObjectAIFollowRef)
      If MCSActor.IsDisabled() == 1
       MCSActor.Enable()
      EndIf
      If MCSActor.IsDead() == 1
       MCSActor.Resurrect()
       MCSActor.ResetHealthAndLimbs()
      EndIf
      MCSAliasActor[MCSEntryNumber].Clear() ;UAliasO
      MCSAliasActor[MCSEntryNumber].ForceRefTo(MCSActor) ;xƂōULɂ
      MCSActor.RemoveFromFaction(MCSFactionStay)
      MCSActor.AddToFaction(MCSFactionFollow)
      MCSActor.MoveTo(Game.GetPlayer(),afXOffset = Utility.RandomInt()*4 - 200,afYOffset = Utility.RandomInt()*4 - 200)
      MCSActor.SetPlayerTeammate()
      MCSActor.EvaluatePackage()
     EndIf
     MCSEntryNumber += 1
    EndWhile
    Debug.Notification("Call All.")

   ElseIf MCSButtonList == 2 ;Make All Companions Do Free
    MCSEntryNumber = 1
    While MCSEntryNumber < 99
     MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
     If MCSActor != None
      If MCSMarkerActor[MCSEntryNumber].GetParentCell() == MCSCellFollow
       MCSActor.SetPlayerTeammate(False)
      EndIf
      MCSMarkerActor[MCSEntryNumber].MoveTo(MCSObjectAIEmptyRef)
      MCSActor.RemoveFromFaction(MCSFactionFollow)
      MCSActor.RemoveFromFaction(MCSFactionStay)
      MCSActor.EvaluatePackage()
     EndIf
     MCSEntryNumber += 1
    EndWhile
    Debug.Notification("Free All.")

   ElseIf MCSButtonList == 3 ;Dismiss All Companions (Do Before Uninstall)
    MCSEntryNumber = 1
    While MCSEntryNumber < 99
     MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
     If MCSActor != None
      If MCSMarkerActor[MCSEntryNumber].GetParentCell() == MCSCellFollow
       MCSActor.SetPlayerTeammate(False)
      EndIf
      MCSMarkerActor[MCSEntryNumber].MoveTo(MCSObjectAIEmptyRef)
      MCSActor.RemoveFromFaction(MCSFactionFollow)
      MCSActor.RemoveFromFaction(MCSFactionStay)
      MCSAliasActor[MCSEntryNumber].Clear()
      MCSActor.EvaluatePackage()
     EndIf
     MCSEntryNumber += 1
    EndWhile
    Debug.Notification("Dismiss All.")

   EndIf
  EndIf ;Xj[Nꍇ̏͂ЂƂ܂I

  If MCSButtonList == 0 ;SneakłȂAIvVListI񂾏ꍇ
   MCSPage = 1
   MCSDone = 0
   While MCSDone == 0 ;Xg܂ł͂ƌJԂ

    MCSEntryNumber = (MCSPage - 1)*7 + 1 ;y[W̐擪҂EntryNumber߂Đݒ
    MCSLineNumber = 0
    While MCSLineNumber < 7 ;ڂ0ŁA\pɎ(6)܂Őݒ肷
     MCSActor = MCSAliasActor[MCSEntryNumber + MCSLineNumber].GetActorReference()
     If MCSActor == None ;Empty
      MCSAliasActor[MCSEntryNumber + MCSLineNumber].ForceRefTo(MCSObjectAIEmptyRef) ;̕\cȂ悤Empty\
      MCSAliasLocation[MCSLineNumber].ForceLocationTo(MCSObjectAIEmptyRef.GetCurrentLocation()) ;Nowhere̕\
      MCSAliasAI[MCSLineNumber].ForceRefTo(MCSObjectAIEmptyRef)
     Else ;Not Empty
      If MCSActor.GetCurrentLocation() == None ;Location݂ȂȂ
       MCSAliasLocation[MCSLineNumber].ForceLocationTo(MCSObjectAIFollowRef.GetCurrentLocation()) ;SomewhereɂĂ
      Else
       MCSAliasLocation[MCSLineNumber].ForceLocationTo(MCSActor.GetCurrentLocation()) ;ꏊݒ
      EndIf
      If MCSActor.IsDisabled() == 1
       MCSAliasAI[MCSLineNumber].ForceRefTo(MCSObjectAIDisabledRef)
      ElseIf MCSActor.IsDead() == 1
       MCSAliasAI[MCSLineNumber].ForceRefTo(MCSObjectAIDeadRef)
      ElseIf MCSMarkerActor[MCSEntryNumber + MCSLineNumber].GetParentCell() == MCSCellFollow
       MCSAliasAI[MCSLineNumber].ForceRefTo(MCSObjectAIFollowRef)
      ElseIf MCSMarkerActor[MCSEntryNumber + MCSLineNumber].GetParentCell() == MCSCellNowhere ;Freȅ
       MCSAliasAI[MCSLineNumber].ForceRefTo(MCSObjectAIFreeRef)
      Else
       MCSAliasAI[MCSLineNumber].ForceRefTo(MCSObjectAIStayRef)
      EndIf
     EndIf
     MCSLineNumber += 1
    EndWhile ;\p̐ݒI
    MCSButtonList = MCSMessageList[MCSPage - 1].Show() ;Xg\ē
    MCSLineNumber = 0
    While MCSLineNumber < 7 ;\pEmpty𖄂߂Ă̂ЂÂ
     If MCSAliasActor[MCSEntryNumber + MCSLineNumber].GetReference() == MCSObjectAIEmptyRef
      MCSAliasActor[MCSEntryNumber + MCSLineNumber].Clear()
     EndIf
     MCSLineNumber += 1
    EndWhile

    If MCSButtonList == 0 ;Previous
     MCSPage -= 1
     If MCSPage == 0
      MCSPage = 14
     EndIf

    ElseIf MCSButtonList == 8 ;Next
     MCSPage += 1
     If MCSPage == 15
      MCSPage = 1
     EndIf

    ElseIf MCSButtonList == 9 ;Cancel
     MCSDone = 1 ;I

    Else ;1-7܂łI
     MCSEntryNumber += MCSButtonList - 1 ;ۂɑIEntryNumberɐݒ肵
     MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()
     If MCSActor != None ;EmptyȂX[
      MCSAliasActor[0].ForceRefTo(MCSActor) ;\pɐݒ
      MCSGlobalEntryNumber.SetValueInt(MCSEntryNumber) ;\pɐݒ
      MCSQuest.UpdateCurrentInstanceGlobal(MCSGlobalEntryNumber)
      MCSButtonList = MCSMessageListOrder.Show() ;̃AN^[̑I\ē
      MCSAliasActor[0].Clear() ;\Ɏg͕ЂÂ

      If MCSButtonList == 0 ;Call
       MCSMarkerActor[MCSEntryNumber].MoveTo(MCSObjectAIFollowRef) ;FollowؖCellɈړ
       If MCSActor.IsDisabled() == 1
        MCSActor.Enable()
       EndIf
       If MCSActor.IsDead() == 1
        MCSActor.Resurrect()
        MCSActor.ResetHealthAndLimbs() ;񂾂Ԃ߂H
       EndIf
       MCSAliasActor[MCSEntryNumber].Clear() ;UAliasO
       MCSAliasActor[MCSEntryNumber].ForceRefTo(MCSActor) ;xƂōULɂ
       MCSActor.RemoveFromFaction(MCSFactionStay)
       MCSActor.AddToFaction(MCSFactionFollow)
       MCSActor.MoveTo(Game.GetPlayer(),afXOffset = Utility.RandomInt()*4 - 200,afYOffset = Utility.RandomInt()*4 - 200)
       MCSActor.SetPlayerTeammate()
       MCSActor.EvaluatePackage()

      ElseIf MCSButtonList == 1 ;Dismiss
       If MCSMarkerActor[MCSEntryNumber].GetParentCell() == MCSCellFollow
        MCSActor.SetPlayerTeammate(False)
       EndIf
       MCSMarkerActor[MCSEntryNumber].MoveTo(MCSObjectAIEmptyRef) ;EmptyؖCellɈړ
       MCSActor.RemoveFromFaction(MCSFactionFollow)
       MCSActor.RemoveFromFaction(MCSFactionStay)
       MCSAliasActor[MCSEntryNumber].Clear()
       MCSActor.EvaluatePackage()

      ElseIf MCSButtonList == 2 ;Up
       If MCSEntryNumber == 1 ;198̓ւ
        MCSActorSub = MCSAliasActor[98].GetActorReference() ;őo̒gm
        MCSAliasActor[1].Clear() ;܂AliasOĂ܂ȂƁAd˒̌ňꖇO@ł̓AreBĂ܂
        MCSAliasActor[98].Clear()
        MCSAliasActor[1].ForceRefTo(MCSActorSub) ;198̒go^
        MCSAliasActor[98].ForceRefTo(MCSActor) ;98Ɍ1̒go^
        MCSMarkerActor[0].MoveTo(MCSMarkerActor[1]) ;1̃}[J[ꏊL
        MCSMarkerActor[1].MoveTo(MCSMarkerActor[98]) ;1̃}[J[98Ɉړ
        MCSMarkerActor[98].MoveTo(MCSMarkerActor[0]) ;98̃}[J[1Ɉړ
       Else ;198̓ւȊOȂ
        MCSActorSub = MCSAliasActor[MCSEntryNumber - 1].GetActorReference()
        MCSAliasActor[MCSEntryNumber].Clear()
        MCSAliasActor[MCSEntryNumber - 1].Clear()
        MCSAliasActor[MCSEntryNumber].ForceRefTo(MCSActorSub) ;Ɉ̒go^
        MCSAliasActor[MCSEntryNumber - 1].ForceRefTo(MCSActor) ;ɂ̌̒go^
        MCSMarkerActor[0].MoveTo(MCSMarkerActor[MCSEntryNumber])
        MCSMarkerActor[MCSEntryNumber].MoveTo(MCSMarkerActor[MCSEntryNumber - 1])
        MCSMarkerActor[MCSEntryNumber - 1].MoveTo(MCSMarkerActor[0])
       EndIf

      ElseIf MCSButtonList == 3 ;Down
       If MCSEntryNumber == 98 ;981̓ւ
        MCSActorSub = MCSAliasActor[1].GetActorReference()
        MCSAliasActor[98].Clear()
        MCSAliasActor[1].Clear()
        MCSAliasActor[98].ForceRefTo(MCSActorSub)
        MCSAliasActor[1].ForceRefTo(MCSActor)
        MCSMarkerActor[0].MoveTo(MCSMarkerActor[98]) ;98̃}[J[ꏊL
        MCSMarkerActor[98].MoveTo(MCSMarkerActor[1]) ;98̃}[J[1Ɉړ
        MCSMarkerActor[1].MoveTo(MCSMarkerActor[0]) ;1̃}[J[98Ɉړ
       Else
        MCSActorSub = MCSAliasActor[MCSEntryNumber + 1].GetActorReference()
        MCSAliasActor[MCSEntryNumber].Clear()
        MCSAliasActor[MCSEntryNumber + 1].Clear()
        MCSAliasActor[MCSEntryNumber].ForceRefTo(MCSActorSub)
        MCSAliasActor[MCSEntryNumber + 1].ForceRefTo(MCSActor)
        MCSMarkerActor[0].MoveTo(MCSMarkerActor[MCSEntryNumber])
        MCSMarkerActor[MCSEntryNumber].MoveTo(MCSMarkerActor[MCSEntryNumber + 1])
        MCSMarkerActor[MCSEntryNumber + 1].MoveTo(MCSMarkerActor[0])
       EndIf

      EndIf ;Back to List̏ꍇ̓X[AǂɂĂ܂Xg\ɖ߂
     EndIf ;EmptyłȂꍇ̏I
    EndIf

   EndWhile
  EndIf

  MCSGlobalWaitFlag.SetValueInt(0) ;Tell Not Busy

 EndIf

EndEvent