Scriptname MCSQuestScript extends Quest  

Spell Property MCSSpellOrder  Auto  
Spell Property MCSSpellTele  Auto  
Spell Property MCSSpellList  Auto  
Spell Property MCSSpellCall  Auto  
Spell Property MCSSpellStop  Auto  
Faction Property MCSFactionEntry  Auto  

GlobalVariable Property MCSGlobalWaitFlag  Auto  
GlobalVariable Property MCSGlobalWaitFlagQuest  Auto  
ReferenceAlias[] Property MCSAliasActor  Auto  ;0ɋ󔒁A͔ԍ
ObjectReference[] Property MCSMarkerActor  Auto  ;0ɋ󔒁A͔ԍ
ObjectReference Property MCSObjectAIEmptyRef  Auto  
Cell Property MCSCellNowhere  Auto  
Cell Property MCSCellFollow  Auto  
Faction Property MCSFactionFollow  Auto  
Faction Property MCSFactionStay  Auto  
ObjectReference Property MCSMarkerPlayerRef  Auto  
Int MCSEntryNumber
Actor MCSActor

Event OnInit()

 If MCSEntryNumber == 0 ;O܂ŔÔ߁A{ɈxsȂ悤
  Game.GetPlayer().AddSpell(MCSSpellOrder)
  Game.GetPlayer().AddSpell(MCSSpellTele)
  Game.GetPlayer().AddSpell(MCSSpellList)
  Game.GetPlayer().AddSpell(MCSSpellCall)
  Game.GetPlayer().AddSpell(MCSSpellStop)
  Game.GetPlayer().AddToFaction(MCSFactionEntry)
  MCSEntryNumber = 1
  RegisterForSingleUpdate(0.3)
 EndIf

EndEvent

Event OnUpdate()

 If MCSMarkerPlayerRef.GetParentCell() != Game.GetPlayer().GetParentCell() ;ZςɕׂȂ
  Utility.Wait(3)
 EndIf
 MCSMarkerPlayerRef.MoveTo(Game.GetPlayer())

 If MCSGlobalWaitFlag.GetValueInt() == 0 && MCSGlobalWaitFlagQuest.GetValueInt() == 0 ;vC[̏閂@Ă炸AdɂȂĂ邩mȂNGXgXNvgƒłȂ
  MCSGlobalWaitFlagQuest.SetValueInt(1) ;NGXgXNvg̍ƒm点
  MCSActor = MCSAliasActor[MCSEntryNumber].GetActorReference()

  If MCSActor == None ;Empty̏ꍇA󂫂l߂
   If MCSEntryNumber < 98
    MCSActor = MCSAliasActor[MCSEntryNumber + 1].GetActorReference()
    MCSAliasActor[MCSEntryNumber + 1].Clear() ;ɃAN^[AliasO
    MCSAliasActor[MCSEntryNumber].ForceRefTo(MCSActor) ;l߂Alias𒅂Bd˒ꖇOƃAreBcȂ悤B
    MCSMarkerActor[MCSEntryNumber].MoveTo(MCSMarkerActor[MCSEntryNumber + 1]) ;̐ݒ̓AN^[ɂĂ̂ŏ͂ŏ[
   Else ;98̏ꍇ
    MCSMarkerActor[98].MoveTo(MCSObjectAIEmptyRef)
   EndIf

  Else ;AN^[ĂꍇAes
   If MCSActor.IsDead() ==0 && MCSActor.IsDisabled() == 0 ;ĂĎ̉Ă

    If MCSMarkerActor[MCSEntryNumber].GetParentCell() == MCSCellFollow ;Follow
     If MCSActor.IsInFaction(MCSFactionFollow) == 0
      MCSActor.AddToFaction(MCSFactionFollow)
     EndIf
     If MCSActor.IsPlayerTeammate() == 0
      MCSActor.SetPlayerTeammate()
     EndIf

    ElseIf MCSMarkerActor[MCSEntryNumber].GetParentCell() != MCSCellNowhere ;Stay
     If MCSActor.GetDistance(MCSMarkerActor[MCSEntryNumber]) > 2000 && MCSActor.IsInCombat() == 0
      MCSActor.RemoveFromFaction(MCSFactionStay)
      MCSActor.EvaluatePackage() ;UpbP[Wʂ̂ɕςȂƂƍXVȂH߂Ȃ₱ƂĂ
      MCSActor.MoveTo(MCSMarkerActor[MCSEntryNumber])
     EndIf
     If MCSActor.IsInFaction(MCSFactionStay) == 0 ;̏̑ƁAX|[ȂǂFaction\
      MCSActor.AddToFaction(MCSFactionStay)
      MCSActor.EvaluatePackage()
     EndIf

    EndIf

   EndIf
  EndIf
  MCSEntryNumber += 1
  If MCSEntryNumber == 99
   MCSEntryNumber = 1
  EndIf
  MCSGlobalWaitFlagQuest.SetValueInt(0) ;NGXgXNvg̍ƏIm点
 EndIf

 RegisterForSingleUpdate(0.3) ;܂0.3bɓ\

EndEvent